# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.HistoryTransactional do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :ChangedByMemberKeyNumeric,
    :FieldKeyNumeric,
    :HistoryTransactionalKeyNumeric,
    :ResourceRecordKeyNumeric,
    :ChangedByMemberID,
    :ChangedByMemberKey,
    :ClassName,
    :FieldKey,
    :FieldName,
    :HistoryTransactionalKey,
    :NewValue,
    :OriginatingSystemHistoryKey,
    :OriginatingSystemID,
    :OriginatingSystemName,
    :PreviousValue,
    :ResourceName,
    :ResourceRecordID,
    :ResourceRecordKey,
    :SourceSystemHistoryKey,
    :SourceSystemID,
    :SourceSystemName,
    :ChangeType,
    :ModificationTimestamp,
    :ChangedByMember,
    :OriginatingSystem,
    :SourceSystem
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :ChangedByMemberKeyNumeric => float() | nil,
    :FieldKeyNumeric => float() | nil,
    :HistoryTransactionalKeyNumeric => float() | nil,
    :ResourceRecordKeyNumeric => float() | nil,
    :ChangedByMemberID => String.t | nil,
    :ChangedByMemberKey => String.t | nil,
    :ClassName => String.t | nil,
    :FieldKey => String.t | nil,
    :FieldName => String.t | nil,
    :HistoryTransactionalKey => String.t | nil,
    :NewValue => String.t | nil,
    :OriginatingSystemHistoryKey => String.t | nil,
    :OriginatingSystemID => float() | nil,
    :OriginatingSystemName => String.t | nil,
    :PreviousValue => String.t | nil,
    :ResourceName => String.t | nil,
    :ResourceRecordID => String.t | nil,
    :ResourceRecordKey => String.t | nil,
    :SourceSystemHistoryKey => String.t | nil,
    :SourceSystemID => float() | nil,
    :SourceSystemName => String.t | nil,
    :ChangeType => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :ChangedByMember => FoyerAPI.Model.Member.t | nil,
    :OriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :SourceSystem => FoyerAPI.Model.Ouid.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.HistoryTransactional do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:ChangedByMember, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:OriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:SourceSystem, :struct, FoyerAPI.Model.Ouid, options)
  end
end

